package RotatingLog;

use FileHandle;

sub new
{
    my ($this, $file, $maxlog, $logno) = @_;
    my  $class = ref($this) || $this;
    my  $self = {};

    bless($self, $class);
    $self->{"file"} = $file;
    ($maxlog=1024*1024) unless( $maxlog );
    ($logno=7) unless( $logno );
    $self->{"maxlog"} = $maxlog;
    $self->{"logno"} = $logno;
    return $self;
}


sub log {
    my( $self, $text ) = @_;

    unless( $self->{"fh"} ) {
	print "RotatingLog: attaching to log file ".($self->{"file"})."\n" if( $main::dl>4 );
	$self->{"fh"} = new FileHandle;
	unless( open( $self->{"fh"}, ">>".($self->{"file"}) ) ) {
	    main::log( "warning", "cannot append to log file ".($self->{"file"}) ) unless( $self->{"warned"} );
	    $self->{"warned"} = 1;
	    undef $self->{"fh"};
	    return;
	}
	select $self->{"fh"};
	$| = 1;
	select STDOUT;
	$self->{"cnt"} = 5;
    }
    return unless( defined $text );
    $self->{"warned"} = 0;
    my $fh = $self->{"fh"};
    print $fh (time)." ".$text."\n";
    return if( $self->{"cnt"} );
    $self->{"cnt"} = 50;
    if( (-s $self->{"file"}) > $self->{"maxlog"} ) {
	close $self->{"fh"};
	undef $self->{"fh"};
	print "rotating status logs\n" if( $main::dl>5 );
	my $i;
	for( $i=$self->{"logno"}; $i; $i-- ) {
	    rename( ($self->{"file"}).".".($i-1), ($self->{"file"}).".".$i );
	}
	rename( $self->{"file"}, ($self->{"file"}).".0" );
	$self->log();
    }
}

1;
