package bscgi;

my $fcgi = 0;
my $deftimeout = 120;
my %skinc;

eval {
    require FCGI;
    $fcgi = 1;
};

use bbdisp;

sub init {
    unless( $main::display ) {
	$main::display = new bbdisp( );
    }
}


sub mainloop {
    my( $func, $skinset, $timeout ) = @_;
    my $go_on = 1;

    init();
    ($timeout = $deftimeout) unless( $timeout );
    $SIG{"ALRM"} = sub { exit(0); };

    while( $go_on ) {
	$go_on = $fcgi;
	if( $fcgi ) {
	    alarm($timeout);
	    last unless( FCGI::accept() >= 0 );
	    my $len = $ENV{"CONTENT_LENGTH"};
	    alarm(0);
	}
	my $query;
	my $data="";
	my $len = 0 + $ENV{'CONTENT_LENGTH'};
	if($len > 0) {
	    my $i;
	    for($i = 0; $i < $len; $i++) {
		my $ch;
		$ch = getc(STDIN);
		last unless( $ch );
		$data .= $ch;
	    }
	}       
	if( $data ) {
	    $query = $data;
	}
	else {
	    $query = $ENV{"QUERY_STRING"};
	}
	my %cgivars;
	my $i;

	for (split( "&", $query )) {
	    if( /^([A-Z]+)=(.*)/i ) {
		my( $var, $val ) = ($1,$2);
		$val =~ s/\+/ /g;
		while( $val =~ /\%([0-9a-f]{2})/i ) {
		    $val = $`.sprintf("%c",hex($1)).$';
		}
		$val =~ s/\"/\'/g;
		$cgivars{$var} = $val;
	    }
	}
	$cgivars{"EXPIRES"} = Platform::strftime("%a, %d %h %Y %T GMT", time + 60);
	my $skins = $skinset;
	main::load_resources();
	if( $main::resources{"skin"} ) {
	    $skins = $main::resources{"skin"};
	}
	if( $cgivars{"SKIN"} ) {
	    $skins = $cgivars{"SKIN"};
	}
	if( defined $skinc{$skins} ) {
	    $skins = $skinc{$skins};
	}
	else {
	    my $l;
	    my $skin;
	    foreach $l ( "default", split(",",$skins) ) {
		$skin = $main::display->read_skin( $l, $skin );
	    };
	    $skinc{$skins} = $skin;
	    $skins = $skin;
	    $skins->{"_BASE"} = $main::display->get_skin( $skin, "WEBROOT.inc" );
	}
	&$func( $skins, %cgivars );
    };
}

1;
