#    Big Sister network monitor
#    Copyright (C) 1998  Thomas Aeby
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#

package rule;
print "reloading rules\n";

# don't flood us with multiple warnings for the same thing
%neighbour = (
    "asterix", "rbb21",
    "mollix", "rbb21",
    "phoenix", "rbb21",
    "docix", "rbb21",
    "bernix", "rber",
    "luzix", "rluz",
    "basix", "rbas",
    "dubix", "rdub",
    "beatnix", "rbb70",

    "rber", "rbb70",
    "rluz", "rbb70",
    "rbas", "rbb70",
    "rdub", "rbb70",
    "rbb21", "rbb70"
);

# the procedure create_events is called each 5 minutes
sub create_events {
    my( $i );
    my( $host, $service, $name, @went_down );

    @went_down = keys %bb_evgen::went_down;
    for( $i=$#went_down; $i>=0; $i-- ) {
	($host,$service) = split( /\./, $name = $went_down[$i] );
	next if( $bb_evgen::is_up{$name} );
	if( $service eq "disk" ) {
	    next;
	}
	elsif( $service eq "cpu" ) {
	    next;
	}
	elsif( $service eq "conn" ) {
	    next if( $neighbour{$host} && $bb_evgen::is_down{$neighbour{$host}.".$service"} );
	    &bb_evgen::event_raise( $name, $host, $service, $service, 70,
		sub { $bb_evgen::is_up{$name} } );
	}
	else {
	    next if( $bb_evgen::is_down{ $host.".conn" } );
	    &bb_evgen::event_raise( $name, $host, $service, $service, 60,
		sub { $bb_evgen::is_up{$name} } );
	}
    }
    return 0;
}


1;
